# testcode

This is just a test project. You can do anything here, test g++, make, cmake,
git, cscope, and IDE projects.

## Getting the project

You can get a copy of this project by clicking on the
[ZIP](http://git.dlma.com/testcode.git/zipball/master)
or [TAR](http://git.dlma.com/testcode.git/tarball/master) buttons
near the top right of the GitList web page.

You can clone from the origin with:

    git clone ssh://USERNAME@dlma.com/~/git/testcode.git

## IDEs

### tmux vim entr

Create two panes in tmux, run vim in one, and run entr in the other with a command like:

    find . -type f \( -name \*.[ch]pp -or -name \*.[ch] \) | \
    entr -c sh -c 'ctags -R *; make -j$(nproc) && valgrind --leak-check=yes product/testcode'

or, to compile with debug info and run in gdb:

    find . -type f \( -name \*.[ch]pp -or -name \*.[ch] \) | \
    entr -c sh -c 'ctags -R *; make debug -j$(nproc) && gdb product/testcode'

Tips: you can also run ctags and cscope, and in vim you can grep and use the QuickFix window with commands like...

    :grep -rI searchterm .
    :cw

### Visual Studio Code and WSL2

Once you've got the [Remote -WSL extension](https://marketplace.visualstudio.com/items?itemName=ms-vscode-remote.remote-wsl)
for WSL, you can invoke Code from the WSL side.

    code .

Or, if it's not in your path, something like...

    /mnt/c/Users/$USER/AppData/Local/Programs/Microsoft\ VS\ Code/bin/code .

### Other IDEs

Look for the presence of their project files. They should work normally.

## Current Features

* Multiple directories for testing build systems and IDEs
* "make" essentially works.

## Is it any good?

[Yes](https://news.ycombinator.com/item?id=3067434).

## To Do

* Compare make vs. cmake vs. autotools
* Experiment with ctags generation

